#!/usr/bin/python3.6
import scipy, numpy, math
from functools import lru_cache

# extend resources for ackerman (sic!)
import resource, sys
resource.setrlimit(resource.RLIMIT_STACK, (2**29,-1))
sys.setrecursionlimit(10**6)

# recursive fibonacci function
def Fibonacci(n): 
    Matrix = numpy.matrix([[0,1],[1,1]])
    vec = numpy.array([[0],[1]])
    fib = numpy.matmul(Matrix**n,vec)
    return fib[0][0]
  
# faculty function
def Faculty(n):
    factorial = math.factorial(n)
    return factorial

# ackermann function
@lru_cache(None)
def Ackermann(m,n):
     if m == 0:
          return (n + 1)
     elif n == 0:
          return Ackermann(m - 1, 1)
     else:
          return Ackermann(m - 1, Ackermann(m, n - 1))

print("Faculty  : ", Faculty(20))
print("Fibonacci: ", Fibonacci(34))
print("Ackermann: ", Ackermann(3, 10))
